using System;
using System.Drawing;
using MonoTouch.Foundation;
using MonoTouch.UIKit;

namespace TableCellGCProblem
{
    public partial class MyTableCell : UITableViewCell
    {
        public static readonly UINib Nib = UINib.FromName("MyTableCell", NSBundle.MainBundle);
        public static readonly NSString Key = new NSString("MyTableCell");

        public Action TapAction { get; set; }

        public MyTableCell(IntPtr handle) : base (handle)
        {
        }

        public static MyTableCell Create()
        {
            return (MyTableCell)Nib.Instantiate(null, null)[0];
        }

        public override void SetSelected(bool selected, bool animated)
        {
            base.SetSelected(selected, animated);

            if (selected && TapAction != null)
                TapAction();
        }
    }
}

