using System;
using System.Drawing;
using MonoTouch.Foundation;
using MonoTouch.UIKit;

namespace TableCellGCProblem
{
    public class MyTableViewSource : UITableViewSource
    {
        // keeping this ref (or a ref to a shared ViewModel) seems to be an issue for GC.
        // Either this ref needs to be set to null (see TableViewController.ViewWillDisappear), or the TapAction needs to be set to null in all the cells (which is difficult to do...how?)
        public MyTableViewController View { get; set; } 

        public MyTableViewSource(MyTableViewController view)
        {
            View = view;
        }

        public override int NumberOfSections(UITableView tableView)
        {
            return 1;
        }

        public override int RowsInSection(UITableView tableview, int section)
        {
            return 100;
        }

        public override string TitleForHeader(UITableView tableView, int section)
        {
            return "Header";
        }

        public override string TitleForFooter(UITableView tableView, int section)
        {
            return "Footer";
        }

        public override UITableViewCell GetCell(UITableView tableView, NSIndexPath indexPath)
        {
            var cell = tableView.DequeueReusableCell(MyTableCell.Key) as MyTableCell;
            if (cell == null)
            {
                cell = MyTableCell.Create();
                cell.TapAction = HandleCellTapped; // comment out this line and the problem also goes away
            }
			
            return cell;
        }

        void HandleCellTapped()
        {
            Console.WriteLine("Cell tapped");
        }
    }
}

